from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import Boolean, Directory, File

Mutplot_V0_1_0 = CommandToolBuilder(tool="mutplot", base_command=["mutplot"], inputs=[ToolInput(tag="in_vcf", input_type=Boolean(optional=True), prefix="--vcf", doc=InputDocumentation(doc="VCF file which contains cultivar and mutant bulk.\nin this order. This VCF file must have AD field.")), ToolInput(tag="in_out", input_type=Directory(optional=True), prefix="--out", doc=InputDocumentation(doc="Output directory. Specified name can exist.")), ToolInput(tag="in_n_bulk", input_type=Boolean(optional=True), prefix="--N-bulk", doc=InputDocumentation(doc="Number of individuals in mutant bulk.")), ToolInput(tag="in_window", input_type=Boolean(optional=True), prefix="--window", doc=InputDocumentation(doc="Window size (kb). [2000]")), ToolInput(tag="in_step", input_type=Boolean(optional=True), prefix="--step", doc=InputDocumentation(doc="Step size (kb). [100]")), ToolInput(tag="in_max_depth", input_type=Boolean(optional=True), prefix="--max-depth", doc=InputDocumentation(doc="Maximum depth of variants which will be used.\nThis cutoff will be applied in both of cultivar\nand bulk. [250]")), ToolInput(tag="in_min_depth", input_type=Boolean(optional=True), prefix="--min-depth", doc=InputDocumentation(doc="Minimum depth of variants which will be used.\nThis cutoff will be applied in both of cultivar\nand bulk. [8]")), ToolInput(tag="in_n_rep", input_type=Boolean(optional=True), prefix="--N-rep", doc=InputDocumentation(doc="Number of replicates for simulation to make\nnull distribution. [5000]")), ToolInput(tag="in_min_snp_index", input_type=Boolean(optional=True), prefix="--min-SNPindex", doc=InputDocumentation(doc="Cutoff of minimum SNP-index for clear results. [0.3]")), ToolInput(tag="in_strand_bias", input_type=Boolean(optional=True), prefix="--strand-bias", doc=InputDocumentation(doc="Filter spurious homo genotypes in cultivar using\nstrand bias. If ADF (or ADR) is higher than this\ncutoff when ADR (or ADF) is 0, that SNP will be\nfiltered out. If you want to supress this filtering,\nplease set this cutoff to 0. [7]")), ToolInput(tag="in_snp_eff", input_type=Boolean(optional=True), prefix="--snpEff", doc=InputDocumentation(doc="Predict causal variant using SnpEff. Please\ncheck available databases in SnpEff.")), ToolInput(tag="in_igv", input_type=File(optional=True), prefix="--igv", doc=InputDocumentation(doc="Output IGV format file to check results on IGV.")), ToolInput(tag="in_species", input_type=Boolean(optional=True), prefix="--species", doc=InputDocumentation(doc="Consider multiple test correction derived by\nHuang et al. (2019). Please spesify a species name.\nWith this option. QTL-seq produces a theoretical threshold.\nCurrently, Arabidopsis, Cucumber, Maize, Rapeseed,\nRice, Tobacco, Tomato, Wheat, and Yeast are supported.")), ToolInput(tag="in_in_del", input_type=Boolean(optional=True), prefix="--indel", doc=InputDocumentation(doc="Plot SNP-index with INDEL.")), ToolInput(tag="in_fig_width", input_type=Boolean(optional=True), prefix="--fig-width", doc=InputDocumentation(doc="Width allocated in chromosome figure. [7.5]")), ToolInput(tag="in_fig_height", input_type=Boolean(optional=True), prefix="--fig-height", doc=InputDocumentation(doc="Height allocated in chromosome figure. [4.0]")), ToolInput(tag="in_white_space", input_type=Boolean(optional=True), prefix="--white-space", doc=InputDocumentation(doc="White space between figures. (This option\nonly affect vertical direction.) [0.6]"))], outputs=[ToolOutput(tag="out_out", output_type=Directory(optional=True), selector=InputSelector(input_to_select="in_out", type_hint=File()), doc=OutputDocumentation(doc="Output directory. Specified name can exist.")), ToolOutput(tag="out_igv", output_type=File(optional=True), selector=InputSelector(input_to_select="in_igv", type_hint=File()), doc=OutputDocumentation(doc="Output IGV format file to check results on IGV."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Mutplot_V0_1_0().translate("wdl", allow_empty_container=True)

